<template>
  <v-container fluid class="pa-0 ma-0">
    <v-row class="pa-0 ma-0">
      <v-col :class="desktop ? '' : 'pa-0'">
        <v-card class="plan-card pa-5">
          <v-row class="pa-0 ma-0">
            <v-col :cols="desktop ? '5' : '12'">
              <v-row class="ma-0 pa-0">
                <v-col :cols="desktop ? '7' : '12'" align-self="center">
                  <v-row
                    :style="desktop ? 'font-size:25px;' : 'font-size:20px'"
                    class="pa-0 ma-0"
                    :justify="desktop ? 'start' : 'center'"
                    v-if="subscription.plan"
                  >
                    <span
                      >Estás en el Plan
                      {{
                        subscription.plan.name.charAt(0).toUpperCase() +
                        subscription.plan.name.slice(1).toLowerCase()
                      }}</span
                    >
                  </v-row>
                </v-col>
                <v-col :cols="desktop ? '5' : '12'">
                  <v-row class="ma-0 pa-0" justify="center">
                    <v-img
                      v-if="subscription.plan && subscription.plan.name"
                      :src="
                        require('@/assets/img/plans/' +
                          subscription.plan.name +
                          '.svg')
                      "
                      class="rounded"
                      max-width="150px"
                      contain
                    />
                  </v-row>
                </v-col>
              </v-row>
            </v-col>
            <v-col align-self="center" :cols="desktop ? '7' : '12'">
              <span class="plan-card-subtitle">¿A qué tengo acceso?</span>
              <ul class="pl-5">
                <li
                  v-for="(feature, featureIndex) in subscription.plan.features"
                  :key="featureIndex"
                  class="roboto plan-card-list-element"
                >
                  {{ feature.description }}
                </li>
              </ul>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="pa-0 ma-0" justify="center py-5">
      <span class="plan-middle-title"
        >Revisa cómo hacer más competitivo tu negocio con Planes que aceleran su
        Transformación.</span
      >
    </v-row>
    <v-row class="pa-0 ma-0" align="stretch" justify="center" v-if="desktop">
      <v-col
        style="max-width: 400px"
        v-for="(plan, index) in plans.filter((e, i) => i >= nextPlanIndex)"
        :key="index"
      >
        <v-card style="height: 100%; !important" class="plan-card pa-5">
          <v-row class="pa-0 ma-0 center-vertical" align="around">
            <div>
              <v-col cols="12">
                <v-row class="ma-0 pa-0">
                  <v-col cols="12" align-self="center">
                    <v-row class="pa-0 ma-0" justify="center">
                      <span class="plan-title-violet"
                        >Plan
                        {{
                          plan.name.charAt(0).toUpperCase() +
                          plan.name.slice(1).toLowerCase()
                        }}</span
                      >
                    </v-row>
                  </v-col>
                  <v-col cols="12">
                    <v-row class="ma-0 pa-0" justify="center">
                      <v-img
                        v-if="plan.name && !isLast"
                        :src="
                          require('@/assets/img/plans/' + plan.name + '.svg')
                        "
                        class="rounded"
                        max-width="150px"
                        contain
                      />
                      <v-img
                        v-if="plan.name && isLast"
                        :src="require('@/assets/img/plans/last.svg')"
                        class="rounded"
                        max-width="150px"
                        contain
                      />
                    </v-row>
                  </v-col>
                </v-row>
              </v-col>
              <v-col align-self="center" style="text-align: center" cols="12">
                <span class="plan-card-body">{{ plan.description }}</span>
              </v-col>
            </div>
            <v-btn
              large
              outlined
              style="background: transparent; border: transparent !important"
              class="button-text tway-violet--text"
              :to="{ name: 'plans' }"
            >
              VER MÁS
            </v-btn>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="pa-0 ma-0" align="stretch" justify="center" v-if="mobile">
      <div
        @click="
          () => {
            counter > nextPlanIndex ? (counter = counter - 1) : '';
          }
        "
        v-if="counter > nextPlanIndex"
        style="margin-right: 80%; margin-top: 50%; z-index: 10"
        class="round-button"
      >
        <v-img
          :src="require('@/assets/img/plans/arrowleft.svg')"
          class="rounded"
          max-width="17px"
          contain
        />
      </div>
      <v-col style="max-width: 400px">
        <v-card style="height: 100%; !important" class="plan-card pa-5">
          <v-row class="pa-0 ma-0 center-vertical" align="around">
            <div>
              <v-col cols="12">
                <v-row class="ma-0 pa-0">
                  <v-col cols="12" align-self="center">
                    <v-row class="pa-0 ma-0" justify="center">
                      <span v-if="plans[counter]" class="plan-title-violet"
                        >Plan {{ plans[counter].name }}</span
                      >
                    </v-row>
                  </v-col>
                  <v-col cols="12">
                    <v-row class="ma-0 pa-0" justify="center">
                      <v-img
                        v-if="plans[counter] && !isLast"
                        :src="
                          require('@/assets/img/plans/' +
                            plans[counter].name +
                            '.svg')
                        "
                        class="rounded"
                        max-width="150px"
                        contain
                      />
                      <v-img
                        v-if="plans[counter] && isLast"
                        :src="require('@/assets/img/plans/last.svg')"
                        class="rounded"
                        max-width="150px"
                        contain
                      />
                    </v-row>
                  </v-col>
                </v-row>
              </v-col>
              <v-col align-self="center" style="text-align: center" cols="12">
                <span v-if="plans[counter]" class="plan-card-body">{{
                  plans[counter].description
                }}</span>
              </v-col>
            </div>
            <v-btn
              large
              outlined
              style="background: transparent; border: transparent !important"
              class="button-text tway-violet--text"
              :to="{ name: 'plans' }"
            >
              VER MÁS
            </v-btn>
          </v-row>
        </v-card>
      </v-col>
      <div
        @click="
          () => {
            counter < plans.length - 1 ? (counter = counter + 1) : '';
          }
        "
        v-if="counter < plans.length - 1"
        style="margin-left: 80%; margin-top: 50%; z-index: 10"
        class="round-button"
      >
        <v-img
          :src="require('@/assets/img/plans/arrowright.svg')"
          class="rounded"
          max-width="17px"
          contain
        />
      </div>
    </v-row>
    <div v-if="mobile" class="pa-0 ma-0 center-between">
      <v-img
        v-for="(plan, index) in plans.filter((e, i) => i >= nextPlanIndex)"
        :key="index"
        :src="
          require('@/assets/img/plans/' +
            (index == counter - nextPlanIndex ? 'selected' : 'notselected') +
            '.svg')
        "
        class="rounded mx-2"
        @click="
          () => {
            counter = index + nextPlanIndex;
          }
        "
        max-width="35px"
        contain
      />
    </div>
  </v-container>
</template>
<style lang="scss" scoped>
.plan-card {
  box-shadow: 0px 5px 14px 0px rgba($color: #000000, $alpha: 0.12) !important;
  border-radius: 40px;
}
.plan-middle-title {
  font-style: normal;
  font-weight: normal;
  font-size: 22px;
  line-height: 30px;
  text-align: center;
  color: #333333;
}
.plan-card-subtitle {
  font-style: normal;
  font-weight: normal;
  font-size: 20px !important;
  line-height: 27px;
  color: #333333;
}
.center-vertical {
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}
.plan-card-list-element {
  font-style: normal;
  font-weight: normal;
  font-size: 16px !important;
  line-height: 24px;
  color: #333333;
}
.plan-title-violet {
  font-style: normal;
  font-weight: normal;
  font-size: 25px;
  line-height: 32px;
  text-align: center;
  color: #7319d5;
}
.center-between {
  width: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  margin-top: 20px !important;
  margin-bottom: 20px !important;
  cursor: pointer;
}
.plan-card-body {
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #000000;
}
.round-button {
  border-radius: 100%;
  background: #7319d5;
  height: 50px;
  position: absolute;
  display: flex;
  justify-content: center;
  align-items: center;
  width: 50px;
  cursor: pointer;
}
</style>

<script>
import SubscriptionService from "@/services/subscriptionService";
import PlanService from "@/services/planService";

export default {
  name: "ClientPlan",

  data: () => ({
    subscription: {
      plan: {
        name: "",
      },
    },
    nextPlanIndex: 0,
    counter: 0,
    plans: [],
    isLast: false,
  }),

  created() {
    PlanService.getPlans()
      .then((response) => {
        this.plans = response.filter((e) => e.type == "SPECIALIST");
        SubscriptionService.getCurrentUserSubscription()
          .then((subscription) => {
            this.subscription = subscription;
            if (this.subscription.plan) {
              this.nextPlanIndex =
                this.plans.findIndex(
                  (e) => e.name == this.subscription.plan.name
                ) + 1;
              this.counter = this.nextPlanIndex;
              if (this.counter == this.plans.length) {
                this.isLast = true;
                this.nextPlanIndex = this.plans.length - 1;
                this.counter = this.plans.length - 1;
              }
            }
          })
          .catch((err) => this.$log.error(err));
      })
      .catch((err) => {
        this.$log.error(err);
      });
  },

  mounted() {
    this.isLoading = false;
  },

  methods: {},
  computed: {
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
